"""
Django settings for information_broker project.

Generated by 'django-admin startproject' using Django 1.11.7.

For more information on this file, see
https://docs.djangoproject.com/en/1.11/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.11/ref/settings/
"""

import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
from django.urls import reverse, reverse_lazy

BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
PROJECT_DIR =os.path.dirname(os.path.abspath(__file__))
STATIC_ROOT = os.path.join(PROJECT_DIR, 'static')
IB_URL = 'http://127.0.0.1:8000/'
#DEV_URL = 'http://localhost:8000'
#PROD_URL = 'http://localhost'
TOKEN_URL = 'http://localhost:8000'
# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.11/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'o_zm@6e!y_6yozwj$*$%v(c8n%+e8hjyk$@l@83ygtpuhkaj_7'
#LOGIN_REDIRECT_URL = 'marketplace'
ACCESS_TOKEN = ''
CORS_ORIGIN_ALLOW_ALL = True
CLIENT_ID = 'baU8LWi0SABAz27dAMl9GuFNP3MZSTnYB7CDHtJk'
CLIENT_SECRET = 'P6Pbo6Tnm9X48kXGAhx1kMJyZzE8rFE0yheXv80Mek6DDVUd8zppYqUjOLB8j6ZtJuIILO2ojpfWXLn7QO3Do5etRs3wZBlVmu3wMeyOpflXphSJoKFTZoBS0xEGN4EG'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True
#ci check6786788994676
ALLOWED_HOSTS = ['*',]


# Application definition

INSTALLED_APPS = [
    # 'django.contrib.admin',
    # 'django.contrib.auth',
    # 'django.contrib.contenttypes',
    # 'django.contrib.sessions',
    # 'django.contrib.messages',
    # 'django.contrib.staticfiles',
    # 'rest_framework_docs',
    # 'drf_autodocs',
    # 'drf_openapi',
    # 'ib.apps.IbConfig',
    # 'rest_framework',
    # 'rest_framework.authtoken',
    # 'oauth2_provider',
    # 'corsheaders',
    # 'rest_framework_swagger',
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    # Native apps
    'ib',
    'rest_framework',
    'rest_framework.authtoken',
    # 3rd party apps
    'cachalot',
    'drf_yasg',
]
USER_TOKEN_KEY_PREFIX = 'token_user_'
MIDDLEWARE = [
    # 'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.contrib.auth.middleware.SessionAuthenticationMiddleware',
    'oauth2_provider.middleware.OAuth2TokenMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'corsheaders.middleware.CorsMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'information_broker.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'information_broker.wsgi.application'


# Database
# https://docs.djangoproject.com/en/1.11/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': os.path.join(BASE_DIR, 'information_broker.sqlite3')
    }
}



# Password validation
# https://docs.djangoproject.com/en/1.11/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/1.11/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.11/howto/static-files/
# LOGIN_URL = 'http://localhost:8000/admin/'

# LOGIN_URL = 'rest_framework:login'
# LOGOUT_URL = 'rest_framework:logout'
#LOGIN_URL = 'http://localhost:8000/admin/'
STATIC_URL = '/static/'

USE_SESSION_AUTH = True

# ==================================
#   CACHE SETTINGS
# ==================================
ORM_CACHE_TIMEOUT = 2592000
CACHES = {
    'default': {
        'BACKEND': 'django.core.cache.backends.memcached.MemcachedCache',
        'LOCATION': '127.0.0.1:11211',
        'TIMEOUT': ORM_CACHE_TIMEOUT,
    }
}

# ==================================
#   CACHALOT SETTINGS
# ==================================
CACHALOT_ENABLED = True
CACHALOT_CACHE = 'default'
CACHALOT_CACHE_RANDOM = True
CACHALOT_INVALIDATE_RAW = True
CACHALOT_TIMEOUT = ORM_CACHE_TIMEOUT


# ==================================
#   SWAGGER SETTINGS
# ==================================
SWAGGER_SETTINGS = {
    'enabled_methods': [
        'get',
        'post',
        'put',
        'patch',
        'delete',
    ],
    'SECURITY_DEFINITIONS': {
        # "oauth": {
        #     "type": "oauth2",
        #     "tokenUrl": "http://127.0.0.1:8000/o/token/",
        #     "authorizationUrl": "http://127.0.0.1:8000/o/authorize/",
        #     "flow": "password",
        #     "scopes": {
        #         "write": "write",
        #         "read": "read"
        #     }
        # },
        'Bearer': {
            'description': "",
            'type': 'apiKey',
            'name': 'Authorization',
            'in': 'header'
        },
    },
    'JSON_EDITOR': False,
}

# "securityDefinitions": {
#     "JWT": {
#         "description": "",
#         "type": "apiKey",
#         "name": "Authorization",
#         "in": "header"
#     },


# AUTHENTICATION_BACKENDS = [
#     'oauth2_provider.backends.OAuth2Backend',
#     'django.contrib.auth.backends.ModelBackend',
# ]

REST_FRAMEWORK = {
    'DEFAULT_VERSIONING_CLASS': 'rest_framework.versioning.URLPathVersioning',
    'DEFAULT_AUTHENTICATION_CLASSES': [
        # 'oauth2_provider.contrib.rest_framework.OAuth2Authentication',
        'rest_framework.authentication.TokenAuthentication',
    ],
    'DEFAULT_PERMISSION_CLASSES': [
        # 'rest_framework.permissions.TokenAuthentication',
        'rest_framework.permissions.IsAuthenticated',
    ],
    'DEFAULT_PARSER_CLASSES': [
        'rest_framework.parsers.JSONParser',
        'rest_framework.parsers.FormParser',
        'rest_framework.parsers.MultiPartParser',

    ]

}


# OAUTH2_PROVIDER = {
#     # this is the list of available scopes
#     'SCOPES': {'read': 'Read scope', 'write': 'Write scope', 'groups': 'Access to your groups'}
# }


# ==================================
#   LOGGING SETTINGS
# ==================================

LOGGING = {
    'version': 1,
    'disable_existing_loggers': True,
    'formatters': {
        'detailed': {
            'class': 'logging.Formatter',
            'format': "[%(asctime)s] - [%(name)s:%(lineno)s] - [%(levelname)s] %(message)s",
        }
    },
    'handlers': {
        'console': {
            'class': 'logging.StreamHandler',
            'level': 'DEBUG',
            'formatter': 'detailed',
        },
        'file': {
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': "{}/ib.log".format(BASE_DIR),
            'mode': 'w',
            'formatter': 'detailed',
            'level': 'DEBUG',
            'maxBytes': 2024 * 2024,
            'backupCount': 5,
        },
    },
    'loggers': {
        'ib': {
            'level': 'DEBUG',
            'handlers': ['console', 'file']
        },
    }
}